mia::CIndepCompAnalysis Class Referenceabstract

`#include <mia/core/ica.hh>`

## Public Types

enum | EApproach { appr_defl , appr_symm , appr_unknown }
typedef std::set< unsigned int > | IndexSet
| defines a set of indices used for mixing
typedef std::unique_ptr< CIndepCompAnalysis > | Pointer

## Public Member Functions

virtual std::vector< float > | get_delta_feature (const IndexSet &plus, const IndexSet &minus) const =0
virtual std::vector< float > | get_feature_row (unsigned int row) const =0
virtual std::vector< float > | get_incomplete_mix (unsigned int idx, const IndexSet &skip) const =0
virtual std::vector< float > | get_mix (unsigned int idx) const =0
virtual std::vector< float > | get_mix_series (unsigned int row) const =0
virtual CSlopeColumns | get_mixing_curves () const =0
virtual unsigned int | get_ncomponents () const =0
virtual std::vector< float > | get_partial_mix (unsigned int idx, const IndexSet &use) const =0
virtual void | initialize (unsigned int series_length, unsigned int slice_size)=0
virtual void | normalize_ICs ()=0
virtual std::vector< float > | normalize_Mix ()=0
virtual bool | run (unsigned int nica, std::vector< std::vector< float > > guess)=0
virtual void | set_approach (EApproach approach)=0
virtual void | set_deterministic_seed (int seed)=0
virtual void | set_max_iterations (int n)=0
virtual void | set_mixing_series (unsigned int index, const std::vector< float > &series)=0
template<class Iterator>
void | set_row (unsigned row, Iterator begin, Iterator end)
virtual | ~CIndepCompAnalysis ()

## Detailed Description

Definition at line 37 of file core/ica.hh.

## Member Typedef Documentation

## IndexSet

typedef std::set<unsigned int> mia::CIndepCompAnalysis::IndexSet

defines a set of indices used for mixing

Definition at line 53 of file core/ica.hh.

## Pointer

typedef std::unique_ptr<CIndepCompAnalysis> mia::CIndepCompAnalysis::Pointer

Definition at line 50 of file core/ica.hh.

## Member Enumeration Documentation

## EApproach

enum mia::CIndepCompAnalysis::EApproach

Separation approach to be used.

Enumerator
appr_defl | Deflation approach - each component is extimated separately
appr_symm | Symmetric approach thet estimates all components at the same time
appr_unknown |

Definition at line 44 of file core/ica.hh.

## Constructor & Destructor Documentation

## ~CIndepCompAnalysis()

virtual mia::CIndepCompAnalysis::~CIndepCompAnalysis | ( |  | ) |

virtual

## Member Function Documentation

## get_delta_feature()

virtual std::vector< float > mia::CIndepCompAnalysis::get_delta_feature | ( | const IndexSet & | plus,
|  | const IndexSet & | minus ) const

pure virtual

Evaluate a mix of the feature signals by adding and subtractig individual features.

Parameters

  plus | features o be added
  minus | features to be subtracted

Returns
  the feature mix

References get_delta_feature().

Referenced by get_delta_feature().

## get_feature_row()

virtual std::vector< float > mia::CIndepCompAnalysis::get_feature_row | ( | unsigned int | row | ) | const

pure virtual

Returns
  the feature vector of row

References get_feature_row().

Referenced by get_feature_row().

## get_incomplete_mix()

virtual std::vector< float > mia::CIndepCompAnalysis::get_incomplete_mix | ( | unsigned int | idx,
|  | const IndexSet & | skip ) const

pure virtual

Evaluate an incomplete mixed signal. Here the features are given that are not to be used.

See also
  get_partial_mix

Parameters

  idx | series index
  skip | a set of feature indices that will be skipped when evaluating the mix

Returns
  the mixed signal

References get_incomplete_mix().

Referenced by get_incomplete_mix().

## get_mix()

virtual std::vector< float > mia::CIndepCompAnalysis::get_mix | ( | unsigned int | idx | ) | const

pure virtual

Returns
  the complete mixed signal at series index idx

References get_mix().

Referenced by get_mix().

## get_mix_series()

virtual std::vector< float > mia::CIndepCompAnalysis::get_mix_series | ( | unsigned int | row | ) | const

pure virtual

Returns
  the mixing signal curve of the feature row

References get_mix_series().

Referenced by get_mix_series().

## get_mixing_curves()

virtual CSlopeColumns mia::CIndepCompAnalysis::get_mixing_curves | ( |  | ) | const

pure virtual

Returns
  a vector containing all mixing curves

References get_mixing_curves().

Referenced by get_mixing_curves().

## get_ncomponents()

virtual unsigned int mia::CIndepCompAnalysis::get_ncomponents | ( |  | ) | const

pure virtual

Returns
  the number of actual ICs

References get_ncomponents().

Referenced by get_ncomponents().

## get_partial_mix()

virtual std::vector< float > mia::CIndepCompAnalysis::get_partial_mix | ( | unsigned int | idx,
|  | const IndexSet & | use ) const

pure virtual

Evaluate an incomplete mixed signal. Here the features are given that are used to create the mix.

See also
  get_incomplete_mix

Parameters

  idx | series index
  use | the set of feature indices that will be used to evaluate the mix

Returns
  an incolmplete mixed signal.

References get_partial_mix().

Referenced by get_partial_mix().

## initialize()

virtual void mia::CIndepCompAnalysis::initialize | ( | unsigned int | series_length,
|  | unsigned int | slice_size )

pure virtual

References initialize().

Referenced by initialize().

## normalize_ICs()

virtual void mia::CIndepCompAnalysis::normalize_ICs | ( |  | ) |

pure virtual

Normalize the ICs in the following manner: Scale and shift the range of the ICs to [-1, 1] Scale the mixing curved to compensate for the required scaling move the means of the time points to compensate for the shifting.

References normalize_ICs().

Referenced by normalize_ICs().

## normalize_Mix()

virtual std::vector< float > mia::CIndepCompAnalysis::normalize_Mix | ( |  | ) |

pure virtual

Normalize the mixing curves to have a zero mean. As a result a mean image is created that containes the sum of the ICs weighted by the required mean shift.

References normalize_Mix().

Referenced by normalize_Mix().

## run()

virtual bool mia::CIndepCompAnalysis::run | ( | unsigned int | nica,
|  | std::vector< std::vector< float > > | guess )

pure virtual

Run the independed component analysis using the given numbers of components

Parameters

  nica | number of indentepended components
  guess | initial guess for the ICA, pass an empty vector of you don't want to use this feature

References run().

Referenced by run().

## set_approach()

virtual void mia::CIndepCompAnalysis::set_approach | ( | EApproach | approach | ) |

pure virtual

Set the ICA approach to either FICA_APPROACH_DEFL(default) or FICA_APPROACH_SYMM.

Parameters

  approach |

References set_approach().

Referenced by set_approach().

## set_deterministic_seed()

virtual void mia::CIndepCompAnalysis::set_deterministic_seed | ( | int | seed | ) |

pure virtual

References set_deterministic_seed().

Referenced by set_deterministic_seed().

## set_max_iterations()

virtual void mia::CIndepCompAnalysis::set_max_iterations | ( | int | n | ) |

pure virtual

sets the number of iterations in the ICA

Parameters

  n |

References set_max_iterations().

Referenced by set_max_iterations().

## set_mixing_series()

virtual void mia::CIndepCompAnalysis::set_mixing_series | ( | unsigned int | index,
|  | const std::vector< float > & | series )

pure virtual

Replace a mixing signal curve

Parameters

  index | of the curve to be replaced
  series | new data for mixing curve

References set_mixing_series().

Referenced by set_mixing_series().

## set_row()

template<class Iterator>

void mia::CIndepCompAnalysis::set_row | ( | unsigned | row,
|  | Iterator | begin,
|  | Iterator | end )

Set on row of input data

Template Parameters

  Iterator | input data iterator, must follow the model of a forward iterator

Parameters

  row | index of the input slice
  begin | start iterator of input data
  end | end iterator of input data

References set_row().

Referenced by set_row().

The documentation for this class was generated from the following file:

- core/ica.hh